;##################################################################
; MRU List
;##################################################################

;#include "\RadASM\GoAsm\inc\debug.a"
;DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
;DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists

; Main.dlg
IDD_DLG1	equ 1000

;MRUList.mnu
IDR_MENU	equ 10000
IDM_FILES	equ 10001
IDM_OPEN	equ 10004
IDM_MRU		equ 10002
IDM_MRU1	equ 10005
IDM_MRU2	equ 10006
IDM_MRU3	equ 10007
IDM_EXIT	equ 10003

; MRU list
MAX_MRUS	equ 3
MAX_MENU_ITEM_LENGTH	equ 30

#Define HKEY_CLASSES_ROOT 80000000h
#Define HKEY_CURRENT_USER 80000001h
#Define HKEY_LOCAL_MACHINE 80000002h
#Define HKEY_USERS 80000003h
#Define HKEY_PERFORMANCE_DATA 80000004h
#Define HKEY_CURRENT_CONFIG 80000005h
#Define HKEY_DYN_DATA 80000006h

#Define MF_BYPOSITION 400h
#Define MIIM_STRING 40h
#Define MIIM_ID 2
;#Define MIIM_TYPE 10h
#Define MIIM_DATA 20h
#Define MFT_STRING 0

#Define WM_INITDIALOG 110h
#Define WM_CLOSE 10h
#Define WM_COMMAND 111h

#Define OFN_NONETWORKBUTTON 00020000h
#Define OFN_EXPLORER 00080000h

#Define MAX_PATH 260
#Define NULL 0
#Define FALSE 0
#Define TRUE 1

#Define MRUF_STRING_LIST 	0 ; String list (most common)
#Define MRUF_BINARY_LIST 	1 ; Binary data
#Define MRUF_DELAYED_SAVE 	2 ; No idea what this does

OPENFILENAME STRUCT
  lStructSize        DD
  hwndOwner          DD
  hInstance          DD
  lpstrFilter        DD
  lpstrCustomFilter  DD
  nMaxCustFilter     DD
  nFilterIndex       DD
  lpstrFile          DD
  nMaxFile           DD
  lpstrFileTitle     DD
  nMaxFileTitle      DD
  lpstrInitialDir    DD
  lpstrTitle         DD
  Flags              DD
  nFileOffset         DW
  nFileExtension      DW
  lpstrDefExt        DD
  lCustData          DD
  lpfnHook           DD
  lpTemplateName     DD
ENDS

MENUITEMINFO STRUCT
  cbSize        DD
  fMask         DD
  fType         DD
  fState        DD
  wID           DD
  hSubMenu      DD
  hbmpChecked   DD
  hbmpUnchecked DD
  dwItemData    DD
  dwTypeData    DD
  cch           DD
ENDS

CREATEMRULIST STRUCT
	cbSize		DD	? ; Size of this structure in BYTES
	nMaxItems	DD	? ; Maximum number of items in list
	dwFlags		DD	? ; Use the flags defined below
	hKey		DD	? ; A registry key to save the list (eg HKEY_LOCAL_MACHINE)
	lpszSubKey	DD	? ; Pointer to a subkey to save the list (eg Software\Company\Program\Preferences\MRUList")
	lpfnCompare	DD	? ; Pointer to an application defined callback to compare the items (for FindMRUString)
ENDS

; Undocumented functions called by ordinal

CreateMRUList = COMCTL32.DLL:151
; CreateMRUList, pCREATEMRULIST
; Returns a handle to the MRU list

FreeMRUList = COMCTL32.DLL:152
; FreeMRUList, hMRUList

AddMRUString = COMCTL32.DLL:153
; AddMRUString, hMRUList, pString
; Returns the zero based index of the item

EnumMRUList =  COMCTL32.DLL:154
; EnumMRUList, hMRUList, dwIndex, pEnumBuffer, cbBuffer
; Fills  pEnumBuffer with the string from the MRU list at position dwIndex
; Use EnumMRUList,hMRUList,-1,0,0 for a count of items

FindMRUString =  COMCTL32.DLL:155
; invoke FindMRUString, hMRUList, pStringToFind , dwStartIndex
; Returns the zero based index of the item, -1 if not found

DelMRUString =  COMCTL32.DLL:156
; DelMRUString, hMRUList, dwIndex

; Haven't played with these yet...
AddMRUData =  COMCTL32.DLL:167
FindMRUData =  COMCTL32.DLL:169

DATA SECTION
	MRUList				CREATEMRULIST	<?>
	MRUTest				DB	"Software\Donkey\TestMRU\Preferences\MRUList",0
	MRUItem1			DB	"C:\Test1",0
	MRUItem2			DB	"C:\Test2",0
	MRUItem3			DB	"C:\Test3",0
	MRUItem4			DB	"C:\Test4",0

	hList				DD	?
	
	hInstance			DD	?
	hMenuMain			DD	?
	hMenuFiles			DD	?
	hMenuMRU			DD	?

	szFilterStr			DB		"Open text files (*.txt)",0,"*.txt",0,0
	szDefExt			DB		"TXT",0
	szOpenCaption		DB		"Open file",0

	ofnFilePath			DB	MAX_PATH DUP (?)

CODE SECTION

Start:
	invoke GetModuleHandleA,0
	mov [hInstance],eax

	mov D[MRUList.cbSize],SIZEOF CREATEMRULIST
	mov D[MRUList.nMaxItems],MAX_MRUS
	mov D[MRUList.dwFlags],MRUF_STRING_LIST
	mov D[MRUList.hKey],HKEY_LOCAL_MACHINE
	mov D[MRUList.lpszSubKey], offset MRUTest
	mov [MRUList.lpfnCompare],offset MRUCompare
	invoke CreateMRUList,offset MRUList
	mov [hList],eax

	invoke DialogBoxParamA,[hInstance],IDD_DLG1,0,ADDR DlgProc,0
	
	invoke FreeMRUList,[hList]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	LOCAL EnumBuffer[MAX_PATH]	:B
	LOCAL mii					:MENUITEMINFO

	mov eax,[uMsg]

	.WMINITDIALOG
	cmp eax,WM_INITDIALOG
	jne >>.WMCOMMAND
		; Get a handle to the MRU menu
		invoke GetMenu,[hwnd]
		mov [hMenuMain],eax
		invoke GetSubMenu,eax,0 ; Get the handle of the files menu
		mov [hMenuFiles],eax
		invoke GetSubMenu,eax,1
		mov [hMenuMRU],eax

		invoke AddMRUString,[hList],offset MRUItem1
		invoke AddMRUString,[hList],offset MRUItem2
		invoke AddMRUString,[hList],offset MRUItem3

		invoke RebuildMRUMenu,[hMenuMRU],[hList],IDM_MRU1		
		jmp >>.EXIT

	.WMCOMMAND
	cmp eax,WM_COMMAND
	jne >>.WMCLOSE
		movzx eax,W[wParam]
		cmp eax,IDM_OPEN
		jne >
			invoke OpenTextDoc, [hwnd]
			or eax,eax
			jz >>.EXIT
			invoke AddMRUString,[hList],offset ofnFilePath
			invoke RebuildMRUMenu,[hMenuMRU],[hList],IDM_MRU1
			jmp >>.EXIT

		:
		cmp eax,IDM_MRU1
		jb >
		cmp eax,IDM_MRU1 + MAX_MRUS
		jae >
			mov D[mii.cbSize],SIZEOF MENUITEMINFO
			mov D[mii.fMask],MIIM_DATA
			invoke GetMenuItemInfoA, [hMenuMRU], eax, FALSE,offset mii
			invoke EnumMRUList,[hList],[mii.dwItemData],offset EnumBuffer,MAX_PATH
			; Just add the string to move it to the top
			; it will not actually be added
			invoke AddMRUString,[hList],offset EnumBuffer
			invoke RebuildMRUMenu,[hMenuMRU],[hList],IDM_MRU1
			jmp >.EXIT

		:
		cmp eax,IDM_EXIT
		jne >.EXIT
			invoke PostMessageA,[hwnd],WM_CLOSE,0,0
			jmp >.EXIT

	.WMCLOSE
	cmp eax,WM_CLOSE
	jne >.DEFPROC
		INVOKE EndDialog,[hwnd],0

	.DEFPROC
		mov eax,FALSE
		ret

	.EXIT

	mov eax, TRUE
	ret
ENDF

MRUCompare FRAME lpszString1,lpszString2
	invoke lstrcmpiA,[lpszString1],[lpszString2]
	RET
ENDF

OpenTextDoc FRAME hDlg
	LOCAL ofn				:OPENFILENAME

	mov D[ofn.lStructSize],SIZEOF OPENFILENAME
	mov eax,[hDlg]
	mov [ofn.hwndOwner],eax
	mov eax,[hInstance]
	mov D[ofn.hInstance],NULL
	mov D[ofn.lpstrFilter],OFFSET szFilterStr
	mov D[ofn.lpstrCustomFilter],NULL
	mov D[ofn.nMaxCustFilter],NULL
	mov D[ofn.nFilterIndex],1
	mov eax,OFFSET ofnFilePath
	mov D[eax],0
	mov [ofn.lpstrFile],eax
	mov D[ofn.nMaxFile],MAX_PATH
	mov D[ofn.lpstrFileTitle],NULL
	mov D[ofn.nMaxFileTitle],NULL
	mov D[ofn.lpstrInitialDir],NULL
	mov [ofn.lpstrTitle],OFFSET szOpenCaption
	mov D[ofn.Flags],OFN_NONETWORKBUTTON + OFN_EXPLORER
	mov D[ofn.lpfnHook],NULL
	mov D[ofn.lpTemplateName],NULL
	mov D[ofn.lpstrDefExt],OFFSET szDefExt
	mov D[ofn.lCustData],NULL

	invoke GetOpenFileNameA,OFFSET ofn
	ret
ENDF

RebuildMRUMenu FRAME hMRU, hMRUList, StartID
	uses edi,esi, ebx
	LOCAL ItemBuffer[MAX_PATH]	:B
	LOCAL MenuBuffer[MAX_PATH]	:B
	LOCAL mii					:MENUITEMINFO

	mov D[mii.cbSize], SIZEOF MENUITEMINFO
	mov D[mii.fMask], MIIM_STRING | MIIM_DATA | MIIM_ID
	mov D[mii.fType],MFT_STRING
	mov D[mii.hSubMenu],0
	mov D[mii.cch],0
	
	; Clean out the MRU menu
	invoke GetMenuItemCount,[hMRU]
	or eax,eax
	jz >L1
	js >L1
	mov edi,eax
	:
		invoke DeleteMenu,[hMRU],0,MF_BYPOSITION
		dec edi
		jnz <
	L1:

	; First find out how many items are in the list
	invoke EnumMRUList,[hMRUList],-1,0,0
	or eax,eax
	jz >L2
	
	; Add the items to the menu in order...
	mov edi,eax
	dec edi
	mov ebx, [StartID]
	xor esi,esi
	:
	invoke EnumMRUList,[hMRUList],esi,offset ItemBuffer,MAX_PATH
	invoke TruncateFileName,offset MenuBuffer,offset ItemBuffer
	lea eax,MenuBuffer
	mov [mii.dwTypeData],eax
	mov [mii.dwItemData], esi
	mov [mii.wID], ebx
	invoke InsertMenuItemA,[hMRU],esi,TRUE,offset mii
	inc ebx
	inc esi
	cmp esi,edi
	jle <
	L2:

	RET
ENDF

TruncateFileName FRAME pOutput,pFileName
	uses edi

	invoke lstrlenA,[pFileName]
	mov edi,eax
	cmp eax, 36
	jle >
		invoke lstrcpynA,[pOutput],[pFileName],4
		invoke lstrcatA,[pOutput],"..."
		sub edi,MAX_MENU_ITEM_LENGTH
		add edi,[pFileName]
		invoke lstrcatA,[pOutput],edi
		ret
	:
		invoke lstrcpyA,[pOutput],[pFileName]
		ret
ENDF
